(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('codemirror/addon/display/placeholder'), require('codemirror/addon/edit/continuelist'), require('codemirror/mode/gfm/gfm'), require('codemirror'), require('rxjs'), require('@angular/animations'), require('@angular/cdk/coercion'), require('@angular/common'), require('@angular/core'), require('@angular/forms'), require('@ng-tangram/components/core'), require('@ng-tangram/components/forms'), require('@ng-tangram/markdown')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/markdown/editor', ['exports', 'codemirror/addon/display/placeholder', 'codemirror/addon/edit/continuelist', 'codemirror/mode/gfm/gfm', 'codemirror', 'rxjs', '@angular/animations', '@angular/cdk/coercion', '@angular/common', '@angular/core', '@angular/forms', '@ng-tangram/components/core', '@ng-tangram/components/forms', '@ng-tangram/markdown'], factory) :
    (global = global || self, factory((global.nt = global.nt || {}, global.nt.markdown = global.nt.markdown || {}, global.nt.markdown.editor = {}), null, null, null, global.CodeMirror, global.rxjs, global.ng.animations, global.ng.cdk.coercion, global.ng.common, global.ng.core, global.ng.forms, global.nt.components.core, global.nt.components.forms, global.nt.markdown));
}(this, (function (exports, placeholder, continuelist, gfm, codemirror, rxjs, animations, coercion, common, core, forms, core$1, forms$1, markdown) { 'use strict';

    var __assign = (this && this.__assign) || function () {
        __assign = Object.assign || function(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    var LINE_REGEXP = /^([^\n]*)(\n|$)/gm;
    var H1_REGEXP = /^#\s/;
    var H1_REGEXP_MULTIPLE = /^(#\s)([^\n]*)(\n|$)/gm;
    var H2_REGEXP = /^#{2}\s/;
    var H2_REGEXP_MULTIPLE = /^(#{2}\s)([^\n]*)(\n|$)/gm;
    var H3_REGEXP = /^#{3}\s/;
    var H3_REGEXP_MULTIPLE = /^(#{3}\s)([^\n]*)(\n|$)/gm;
    var H4_REGEXP = /^#{4}\s/;
    var H4_REGEXP_MULTIPLE = /^(#{4}\s)([^\n]*)(\n|$)/gm;
    var H5_REGEXP = /^#{5}\s/;
    var H5_REGEXP_MULTIPLE = /^(#{5}\s)([^\n]*)(\n|$)/gm;
    var H6_REGEXP = /^#{6}\s/;
    var H6_REGEXP_MULTIPLE = /^(#{6}\s)([^\n]*)(\n|$)/gm;
    var UL_REGEXP = /^[*\-+]\s/;
    var UL_REGEXP_MULTIPLE = /^([*\-+]\s)([^\n]*)(\n|$)/gm;
    var OL_REGEXP = /^\d+\.\s+/;
    var OL_REGEXP_MULTIPLE = /^(\d+\.\s)([^\n]*)(\n|$)/gm;
    var CODE_REGEXP = /^``````/;
    var QUOTE_REGEXP = /^\>\s|\>/;
    var QUOTE_REGEXP_MULTIPLE = /^(\>\s|\>)([^\n]*)(\n|$)/gm;
    function header(size, doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        var single = new RegExp("^#{" + size + "}\\s");
        var multi = new RegExp("^(#{" + size + "}\\s)([^\\n]*)(\\n|$)", 'gm');
        var line = new RegExp("^(#{" + size + "}\\s)([^\\n]*)(\\n|$)", 'gm');
        var start = doc.getCursor('start');
        var end = doc.getCursor('end');
        var origin = doc.getRange({ line: start.line, ch: 0 }, end);
        var replacement = '';
        var symbol = Array(size).fill('#').join('');
        var startOffset = 0, endOffset = 0;
        if (erase) {
            replacement = origin.replace(multi, function (_match, $1, $2, $3) {
                endOffset = $1.length;
                return "" + $2 + $3;
            });
            startOffset = doc.getLine(start.line).match(single) ? -size - 1 : 0;
            endOffset = doc.getLine(end.line).match(single) ? -endOffset : 0;
        }
        else {
            replacement = origin
                .replace(/^(#{1,6}\s)([^\n]*)(\n|$)/gm, function (_match, _$1, $2, $3) { return "" + $2 + $3; })
                .replace(LINE_REGEXP, function (match) { return !match.trim() && multiple ? match : symbol + " " + match; });
            startOffset = doc.getLine(start.line).match(single) ? 0 : size + 1;
            endOffset = doc.getLine(end.line).match(single) ? 0 : size + 1;
        }
        doc.replaceRange(replacement, { line: start.line, ch: 0 }, end);
        doc.setSelection({ line: start.line, ch: start.ch + startOffset }, { line: end.line, ch: end.ch + (multiple ? endOffset : startOffset) }, { scroll: false });
    }
    function h1(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        header(1, doc, erase, multiple);
    }
    function h2(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        header(2, doc, erase, multiple);
    }
    function h3(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        header(3, doc, erase, multiple);
    }
    function h4(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        header(4, doc, erase, multiple);
    }
    function h5(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        header(5, doc, erase, multiple);
    }
    function h6(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        header(6, doc, erase, multiple);
    }
    function ul(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        var start = doc.getCursor('start');
        var end = doc.getCursor('end');
        var origin = doc.getRange({ line: start.line, ch: 0 }, end);
        var replacement = '';
        var startOffset = 0, endOffset = 0;
        if (erase) {
            replacement = origin.replace(UL_REGEXP_MULTIPLE, function (_match, $1, $2, $3) {
                endOffset = $1.length;
                return "" + $2 + $3;
            });
            startOffset = doc.getLine(start.line).match(UL_REGEXP) ? -2 : 0;
            endOffset = doc.getLine(end.line).match(UL_REGEXP) ? -endOffset : 0;
        }
        else {
            replacement = origin.replace(LINE_REGEXP, function (match) { return !match.trim() && multiple ? match : "- " + match; });
            startOffset = doc.getLine(start.line).match(UL_REGEXP) ? 0 : 2;
            endOffset = doc.getLine(end.line).match(UL_REGEXP) ? 0 : 2;
        }
        doc.replaceRange(replacement, { line: start.line, ch: 0 }, end);
        doc.setSelection({ line: start.line, ch: start.ch + startOffset }, { line: end.line, ch: end.ch + (multiple ? endOffset : startOffset) }, { scroll: false });
    }
    function ol(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        var start = doc.getCursor('start');
        var end = doc.getCursor('end');
        var origin = doc.getRange({ line: start.line, ch: 0 }, end);
        var replacement = '';
        var startOffset = 0, index = 0, endOffset = 0;
        if (erase) {
            replacement = origin.replace(OL_REGEXP_MULTIPLE, function (_match, $1, $2, $3) {
                startOffset = startOffset > 0 ? startOffset : $1.length;
                endOffset = $1.length;
                return "" + $2 + $3;
            });
            startOffset = doc.getLine(start.line).match(OL_REGEXP) ? -startOffset : 0;
            endOffset = doc.getLine(end.line).match(OL_REGEXP) ? -endOffset : 0;
        }
        else {
            replacement = origin.replace(LINE_REGEXP, function (match) { return !match.trim() && multiple ? match : ++index + ". " + match; });
            startOffset = doc.getLine(start.line).match(OL_REGEXP) ? 0 : 3;
            endOffset = doc.getLine(end.line).match(OL_REGEXP) ? 0 : index.toString().length + 2;
        }
        doc.replaceRange(replacement, { line: start.line, ch: 0 }, end);
        doc.setSelection({ line: start.line, ch: start.ch + startOffset }, { line: end.line, ch: end.ch + (multiple ? endOffset : startOffset) }, { scroll: false });
    }
    function link(doc, _erase, _multiple) {
        if (_multiple === void 0) { _multiple = false; }
        var start = doc.getCursor('start');
        var end = doc.getCursor('end');
        var selection = doc.getSelection() || '', from = { line: start.line, ch: start.ch + 1 }, to = { line: end.line, ch: end.ch + (start.line === end.line ? 1 : 0) };
        doc.replaceRange("[" + selection + "](http://)", start, end, selection);
        doc.setSelection(from, to, { scroll: false });
    }
    function image(doc, _erase, _multiple) {
        if (_multiple === void 0) { _multiple = false; }
        var start = doc.getCursor('start');
        var end = doc.getCursor('end');
        var selection = doc.getSelection(), from = { line: start.line, ch: start.ch + 2 }, to = { line: end.line, ch: end.ch + (start.line === end.line ? 2 : 0) };
        doc.replaceRange("![" + selection + "](http://)", start, end, selection);
        doc.setSelection(from, to, { scroll: false });
    }
    function table(doc, _erase, _multiple) {
        if (_multiple === void 0) { _multiple = false; }
        var template = "\n| Column 1 | Column 2 | Column 3 |\n| -------- | -------- | -------- |\n| Text     | Text     | Text     |\n";
        var end = doc.getCursor('end');
        doc.replaceRange(template, { line: end.line + 1, ch: 0 });
    }
    function bold(doc, _erase, _multiple) {
        if (_multiple === void 0) { _multiple = false; }
        var start = doc.getCursor('start');
        var end = doc.getCursor('end');
        var selection = doc.getSelection() || '', from = { line: start.line, ch: start.ch + 2 }, to = { line: end.line, ch: end.ch + (start.line === end.line ? 2 : 0) };
        doc.replaceRange("**" + selection + "**", start, end, selection);
        doc.setSelection(from, to, { scroll: false });
    }
    function italic(doc, _erase, _multiple) {
        if (_multiple === void 0) { _multiple = false; }
        var start = doc.getCursor('start');
        var end = doc.getCursor('end');
        var selection = doc.getSelection() || '', from = { line: start.line, ch: start.ch + 1 }, to = { line: end.line, ch: end.ch + (start.line === end.line ? 1 : 0) };
        doc.replaceRange("*" + selection + "*", start, end, selection);
        doc.setSelection(from, to, { scroll: false });
    }
    function strikethrough(doc, _erase, _multiple) {
        if (_multiple === void 0) { _multiple = false; }
        var start = doc.getCursor('start');
        var end = doc.getCursor('end');
        var selection = doc.getSelection() || '', from = { line: start.line, ch: start.ch + 2 }, to = { line: end.line, ch: end.ch + (start.line === end.line ? 2 : 0) };
        doc.replaceRange("~~" + selection + "~~", start, end, selection);
        doc.setSelection(from, to, { scroll: false });
    }
    function code(doc, _erase, _multiple) {
        if (_multiple === void 0) { _multiple = false; }
        var start = doc.getCursor('start');
        var end = doc.getCursor('end');
        var endLine = doc.getLine(end.line);
        var from = __assign(__assign({}, start), { ch: 0 });
        var to = __assign(__assign({}, end), { ch: endLine.length });
        var selection = doc.getRange(from, to);
        doc.replaceRange("```\n" + selection + "\n```\n", from, to, selection);
        doc.setCursor(start.line, 3);
    }
    function quote(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        var start = doc.getCursor('start');
        var end = doc.getCursor('end');
        var origin = doc.getRange({ line: start.line, ch: 0 }, end);
        var replacement = '';
        var startOffset = 0, endOffset = 0;
        if (erase) {
            replacement = origin.replace(QUOTE_REGEXP_MULTIPLE, function (_match, $1, $2, $3) {
                endOffset = $1.length;
                return "" + $2 + $3;
            });
            startOffset = doc.getLine(start.line).match(QUOTE_REGEXP) ? -2 : 0;
            endOffset = doc.getLine(end.line).match(QUOTE_REGEXP) ? -endOffset : 0;
        }
        else {
            replacement = origin.replace(LINE_REGEXP, function (match) { return !match.trim() && multiple ? match : "> " + match; });
            startOffset = doc.getLine(start.line).match(QUOTE_REGEXP) ? 0 : 2;
            endOffset = doc.getLine(end.line).match(QUOTE_REGEXP) ? 0 : 2;
        }
        doc.replaceRange(replacement, { line: start.line, ch: 0 }, end);
        doc.setSelection({ line: start.line, ch: start.ch + startOffset }, { line: end.line, ch: end.ch + (multiple ? endOffset : startOffset) }, { scroll: false });
    }
    var commands = {
        bold: bold, italic: italic, strikethrough: strikethrough,
        h1: h1, h2: h2, h3: h3, h4: h4, h5: h5, h6: h6,
        ul: ul, ol: ol,
        code: code, quote: quote,
        link: link, image: image, table: table
    };

    var NtMarkdownEditorConfig = (function () {
        function NtMarkdownEditorConfig() {
            this.actions = [
                ['bold', 'italic', 'strikethrough'],
                ['h1', 'h2', 'h3', 'h4', 'h5', 'h6'],
                ['code', 'quote'],
                ['ul', 'ol'],
                ['link', 'image', 'table'],
                ['preview', 'help']
            ];
        }
        return NtMarkdownEditorConfig;
    }());
    var NT_MARKDOWN_EDITOR_CONFIG = new core.InjectionToken('nt-markdown-editor-config');

    var DEFAULT_MARKDOWN_EDITOR_ICONS = {
        bold: 'fa fa-bold',
        italic: 'fa fa-italic',
        strikethrough: 'fa fa-strikethrough',
        h1: 'fa fa-heading fa-heading-x fa-heading-1',
        h2: 'fa fa-heading fa-heading-x fa-heading-2',
        h3: 'fa fa-heading fa-heading-x fa-heading-3',
        h4: 'fa fa-heading fa-heading-x fa-heading-4',
        h5: 'fa fa-heading fa-heading-x fa-heading-5',
        h6: 'fa fa-heading fa-heading-x fa-heading-6',
        code: 'fa fa-code',
        quote: 'fa fa-quote-left',
        ul: 'fa fa-list-ul',
        ol: 'fa fa-list-ol',
        link: 'fa fa-link',
        image: 'fa fa-image',
        table: 'fa fa-table',
        line: 'fa fa-minus',
        preview: 'fas fa-columns',
        help: 'fab fa-markdown',
        undo: 'fa fa-reply',
        redo: 'fa fa-share',
        fill: 'fa fa-arrows-alt',
        compress: 'fa fa-compress'
    };
    var NT_MARKDOWN_EDITOR_ICONS = new core.InjectionToken('nt-markdown-editor-icons');

    var __extends = (this && this.__extends) || (function () {
        var extendStatics = function (d, b) {
            extendStatics = Object.setPrototypeOf ||
                ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
            return extendStatics(d, b);
        };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var __assign$1 = (this && this.__assign) || function () {
        __assign$1 = Object.assign || function(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
            }
            return t;
        };
        return __assign$1.apply(this, arguments);
    };
    var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __param = (this && this.__param) || function (paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    };
    var DEFAULT_MIN_ROWS = 10, DEFAULT_MAX_ROWS = 20, MIN_ROWS_VALUE = 1, MAX_ROWS_VALUE = 100;
    var NtMarkdownEditorComponent = (function (_super) {
        __extends(NtMarkdownEditorComponent, _super);
        function NtMarkdownEditorComponent(_renderer, _changeDetectorRef, platformId, ngControl, _icons, _config) {
            var _this = _super.call(this) || this;
            _this._renderer = _renderer;
            _this._changeDetectorRef = _changeDetectorRef;
            _this.platformId = platformId;
            _this.ngControl = ngControl;
            _this._destroy = new rxjs.Subject();
            _this._syncScrollElements = [];
            _this._syncScrollEvent = new rxjs.Subject();
            _this._value = '';
            _this.fillScreen = false;
            _this.previewMode = false;
            _this.activeActions = [];
            _this.activeActionsSnapshot = [];
            _this._minHeight = "100px";
            _this._maxHeight = "100px";
            _this._focused = false;
            _this.placeholder = '';
            _this._disabled = false;
            _this._required = false;
            _this._minRows = DEFAULT_MIN_ROWS;
            _this._maxRows = DEFAULT_MAX_ROWS;
            _this._theme = 'default';
            _this._onChange = function () { };
            _this._onTouched = function () { };
            if (_this.ngControl) {
                _this.ngControl.valueAccessor = _this;
            }
            _this.config = __assign$1(__assign$1({}, new NtMarkdownEditorConfig()), _config);
            _this.icons = __assign$1(__assign$1({}, DEFAULT_MARKDOWN_EDITOR_ICONS), _icons);
            return _this;
        }
        NtMarkdownEditorComponent_1 = NtMarkdownEditorComponent;
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "value", {
            get: function () { return this._value; },
            set: function (value) {
                this._value = value;
                if (this.instance) {
                    this.instance.setValue(value);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "empty", {
            get: function () { return !this.value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "focused", {
            get: function () { return this._focused; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "disabled", {
            get: function () { return this._disabled; },
            set: function (value) { this._disabled = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "required", {
            get: function () { return this._required; },
            set: function (value) { this._required = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "minRows", {
            get: function () { return this._minRows; },
            set: function (value) {
                var newValue = coercion.coerceNumberProperty(value) || 0;
                this._minRows = newValue < MIN_ROWS_VALUE ? MIN_ROWS_VALUE : newValue;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "maxRows", {
            get: function () { return this._maxRows; },
            set: function (value) {
                var newValue = coercion.coerceNumberProperty(value) || 0;
                this._maxRows = newValue > MAX_ROWS_VALUE ? MAX_ROWS_VALUE : newValue;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "theme", {
            get: function () { return this._theme; },
            set: function (value) { this._theme = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "history", {
            get: function () {
                if (this.instance) {
                    var doc = this.instance.getDoc();
                    return doc.historySize();
                }
                return { undo: 0, redo: 0 };
            },
            enumerable: true,
            configurable: true
        });
        NtMarkdownEditorComponent.prototype.ngOnInit = function () {
            if (common.isPlatformBrowser(this.platformId)) {
                this._codeMirrorInit();
            }
        };
        NtMarkdownEditorComponent.prototype.ngOnChanges = function (changes) {
            var rowChanges = changes.minRows || changes.maxRows;
            if (rowChanges && !rowChanges.firstChange) {
                this._setEditorHeightRange();
            }
        };
        NtMarkdownEditorComponent.prototype.ngOnDestroy = function () {
            this._destroy.next();
            this._destroy.complete();
            this._unsubscribeScrolls();
        };
        NtMarkdownEditorComponent.prototype.writeValue = function (value) {
            this.value = value;
        };
        NtMarkdownEditorComponent.prototype.registerOnChange = function (fn) {
            this._onChange = fn;
        };
        NtMarkdownEditorComponent.prototype.registerOnTouched = function (fn) {
            this._onTouched = fn;
        };
        NtMarkdownEditorComponent.prototype.focus = function () {
            if (!this.disabled) {
                this.instance.focus();
            }
        };
        NtMarkdownEditorComponent.prototype.setDisabledState = function (isDisabled) {
            this._disabled = isDisabled;
        };
        NtMarkdownEditorComponent.prototype.execCommand = function (type) {
            var _this = this;
            if (type === 'preview') {
                this.previewMode = !this.previewMode;
                this._actionMatches();
                setTimeout(function () {
                    _this.instance.refresh();
                    _this.previewMode ? _this._subscribeScrolls() : _this._unsubscribeScrolls();
                });
            }
            else if (type === 'help') {
                window.open('https://guides.github.com/features/mastering-markdown/', '_blank');
            }
            else {
                var activeted = this.activeActions.indexOf(type) > -1;
                var doc = this.instance.getDoc();
                var start = doc.getCursor('start');
                var end = doc.getCursor('end');
                var multiple = end.line - start.line > 0;
                var command = commands[type];
                command && command(doc, activeted, multiple);
                this.instance.save();
                this.instance.focus();
            }
        };
        NtMarkdownEditorComponent.prototype.undo = function () {
            this.instance.getDoc().undo();
        };
        NtMarkdownEditorComponent.prototype.redo = function () {
            this.instance.getDoc().redo();
        };
        NtMarkdownEditorComponent.prototype.changeScreenFilled = function (fillScreen) {
            this.fillScreen = fillScreen;
            this.instance.refresh();
            this._setEditorHeightRange();
        };
        NtMarkdownEditorComponent.prototype._subscribeScrolls = function () {
            var _this = this;
            var callback = function (event) {
                var element = event.target;
                var scrollYUpdated = element.scrollTop !== element.previousScrollY;
                if (scrollYUpdated) {
                    _this._scrollTo(element);
                }
                element.previousScrollY = element.scrollTop;
            };
            var editorScrollElement = this.instance.getScrollerElement();
            this._syncScrollElements.push(editorScrollElement, this.markdown.nativeElement);
            this._syncScrollElements.forEach(function (element) {
                return element.addEventListener('scroll', element.callback = callback);
            });
            this._syncScrollSubscription = this._syncScrollEvent.subscribe(function (event) {
                _this._syncScrollElements
                    .filter(function (element) { return event.owner !== element; })
                    .forEach(function (element) {
                    scrollY = element.previousScrollY = Math.round(event.rateY * (element.scrollHeight - element.clientHeight));
                    if (Math.round(element.scrollTop - scrollY)) {
                        element.scrollTop = scrollY;
                    }
                });
            });
            this._scrollTo(editorScrollElement);
        };
        NtMarkdownEditorComponent.prototype._unsubscribeScrolls = function () {
            if (this._syncScrollSubscription && !this._syncScrollSubscription.closed) {
                this._syncScrollSubscription.unsubscribe();
            }
            if (this._syncScrollElements) {
                this._syncScrollElements.forEach(function (element) {
                    return element.removeEventListener('scroll', element.callback);
                });
                this._syncScrollElements = [];
            }
        };
        NtMarkdownEditorComponent.prototype._scrollTo = function (element) {
            this._syncScrollEvent.next({
                scrollY: element.scrollTop,
                rateY: element.scrollTop / (element.scrollHeight - element.clientHeight),
                owner: element
            });
        };
        NtMarkdownEditorComponent.prototype._codeMirrorInit = function () {
            var _this = this;
            if (typeof codemirror.fromTextArea === 'function') {
                this.editor.nativeElement.value = this.value;
                this.instance = codemirror.fromTextArea(this.editor.nativeElement, {
                    mode: 'gfm',
                    lineWrapping: true,
                    theme: this.theme || 'default',
                    placeholder: this.placeholder,
                    extraKeys: { Enter: 'newlineAndIndentContinueMarkdownList' },
                });
                this._setEditorHeightRange();
                this.instance.on('change', this._onCodeMirrorChange.bind(this));
                this.instance.on('cursorActivity', this._onCodeMirrorCursorActivity.bind(this));
                this.instance.on('focus', this._onCodeMirrorFocus.bind(this));
                this.instance.on('blur', this._onCodeMirrorBlur.bind(this));
                this._destroy.subscribe(function () {
                    _this.instance.off('change', _this._onCodeMirrorChange);
                    _this.instance.off('cursorActivity', _this._onCodeMirrorCursorActivity);
                    _this.instance.off('focus', _this._onCodeMirrorFocus);
                    _this.instance.off('blur', _this._onCodeMirrorBlur);
                    _this.instance.toTextArea();
                    _this._changeDetectorRef.markForCheck();
                });
                Promise.resolve().then(function () { return _this.instance.refresh(); });
            }
        };
        NtMarkdownEditorComponent.prototype._onCodeMirrorChange = function (instance) {
            this._actionMatches();
            this._value = instance.getValue();
            this._onChange(this._value);
            this._onTouched();
            this._changeDetectorRef.markForCheck();
        };
        NtMarkdownEditorComponent.prototype._onCodeMirrorCursorActivity = function () {
            this._actionMatches();
            this._changeDetectorRef.markForCheck();
        };
        NtMarkdownEditorComponent.prototype._onCodeMirrorFocus = function () {
            this._focused = true;
            this._changeDetectorRef.markForCheck();
        };
        NtMarkdownEditorComponent.prototype._onCodeMirrorBlur = function () {
            this._focused = false;
            this._changeDetectorRef.markForCheck();
        };
        NtMarkdownEditorComponent.prototype._actionMatches = function () {
            var doc = this.instance.getDoc();
            var start = doc.getCursor('start');
            var end = doc.getCursor('end');
            var range = doc.getRange({ line: start.line, ch: 0 }, end);
            this.activeActions = [];
            if (range.match(/^#\s/gm)) {
                this.activeActions.push('h1');
            }
            if (range.match(/^#{2}\s/gm)) {
                this.activeActions.push('h2');
            }
            if (range.match(/^#{3}\s/gm)) {
                this.activeActions.push('h3');
            }
            if (range.match(/^#{4}\s/gm)) {
                this.activeActions.push('h4');
            }
            if (range.match(/^#{5}\s/gm)) {
                this.activeActions.push('h5');
            }
            if (range.match(/^#{6}\s/gm)) {
                this.activeActions.push('h6');
            }
            if (range.match(/^[*\-+]\s/gm)) {
                this.activeActions.push('ul');
            }
            if (range.match(/^\d+\.\s+/gm)) {
                this.activeActions.push('ol');
            }
            if (range.match(/^\>+/gm)) {
                this.activeActions.push('quote');
            }
            if (this.previewMode) {
                this.activeActions.push('preview');
            }
        };
        NtMarkdownEditorComponent.prototype._setEditorHeightRange = function () {
            if (common.isPlatformBrowser(this.platformId) && !!this.instance) {
                var scrollElement = this.instance.getScrollerElement();
                var style = window.getComputedStyle(scrollElement);
                if (this.fillScreen) {
                    this._minHeight = "100%";
                    this._maxHeight = "100%";
                    this._renderer.setStyle(scrollElement, 'min-height', this._minHeight);
                    this._renderer.setStyle(scrollElement, 'max-height', this._maxHeight);
                }
                else if (style && style.lineHeight) {
                    var lineHeight = parseFloat(style.lineHeight.replace('px', ''));
                    this._minHeight = this.minRows * lineHeight + "px";
                    this._maxHeight = this.maxRows * lineHeight + "px";
                    this._renderer.setStyle(scrollElement, 'min-height', this._minHeight);
                    this._renderer.setStyle(scrollElement, 'max-height', this._maxHeight);
                }
            }
        };
        var NtMarkdownEditorComponent_1;
        NtMarkdownEditorComponent.ctorParameters = function () { return [
            { type: core.Renderer2 },
            { type: core.ChangeDetectorRef },
            { type: Object, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] }] },
            { type: forms.NgControl, decorators: [{ type: core.Optional }, { type: core.Self }] },
            { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [NT_MARKDOWN_EDITOR_ICONS,] }] },
            { type: NtMarkdownEditorConfig, decorators: [{ type: core.Optional }, { type: core.Inject, args: [NT_MARKDOWN_EDITOR_CONFIG,] }] }
        ]; };
        __decorate([
            core.ViewChild('editor', { static: true })
        ], NtMarkdownEditorComponent.prototype, "editor", void 0);
        __decorate([
            core.ViewChild('markdown', { static: false, read: core.ElementRef })
        ], NtMarkdownEditorComponent.prototype, "markdown", void 0);
        __decorate([
            core.Input()
        ], NtMarkdownEditorComponent.prototype, "value", null);
        __decorate([
            core.Input()
        ], NtMarkdownEditorComponent.prototype, "placeholder", void 0);
        __decorate([
            core.Input()
        ], NtMarkdownEditorComponent.prototype, "disabled", null);
        __decorate([
            core.Input()
        ], NtMarkdownEditorComponent.prototype, "required", null);
        __decorate([
            core.Input()
        ], NtMarkdownEditorComponent.prototype, "minRows", null);
        __decorate([
            core.Input()
        ], NtMarkdownEditorComponent.prototype, "maxRows", null);
        __decorate([
            core.Input()
        ], NtMarkdownEditorComponent.prototype, "theme", null);
        NtMarkdownEditorComponent = NtMarkdownEditorComponent_1 = __decorate([
            core.Component({
                selector: 'nt-markdown-editor',
                template: "<div class=\"nt-markdown-editor-tools\" [class.tools-disable]=\"previewMode\">\n  <div class=\"tools-group\" *ngFor=\"let group of config.actions\">\n    <div class=\"tools-item\" *ngFor=\"let action of group\"\n    [class.active]=\"activeActions.indexOf(action) > -1\"\n    (click)=\"execCommand(action)\">\n      <span [class]=\"icons[action]\"></span>\n    </div>\n  </div>\n  <div class=\"tools-group\">\n    <div class=\"tools-item\" [class.disabled]=\"history.undo === 0\" (click)=\"undo()\">\n      <span [class]=\"icons['undo']\"></span>\n    </div>\n    <div class=\"tools-item\" [class.disabled]=\"history.redo === 0\" (click)=\"redo()\">\n      <span [class]=\"icons['redo']\"></span>\n    </div>\n  </div>\n  <div class=\"tools-group\">\n    <div class=\"tools-item\" (click)=\"changeScreenFilled(true)\" *ngIf=\"!fillScreen\">\n      <span [class]=\"icons['fill']\"></span>\n    </div>\n    <div class=\"tools-item\" (click)=\"changeScreenFilled(false)\" *ngIf=\"fillScreen\">\n      <span [class]=\"icons['compress']\"></span>\n    </div>\n  </div>\n</div>\n<div class=\"nt-markdown-editor-container\">\n  <div class=\"nt-markdown-editor-content\">\n    <textarea #editor></textarea>\n  </div>\n  <div #markdown class=\"nt-markdown-editor-preview\"\n    *ngIf=\"previewMode\"\n    [style.minHeight]=\"_minHeight\"\n    [style.maxHeight]=\"_maxHeight\"\n    [@fade]>\n    <nt-markdown [data]=\"value\"></nt-markdown>\n  </div>\n</div>\n",
                encapsulation: core.ViewEncapsulation.None,
                changeDetection: core.ChangeDetectionStrategy.OnPush,
                providers: [
                    { provide: forms$1.NtFormFieldControl, useExisting: NtMarkdownEditorComponent_1 }
                ],
                animations: [
                    animations.trigger('fade', [
                        animations.transition('void => *', core$1.fadeIn(.15))
                    ])
                ],
                host: {
                    'class': 'nt-markdown-editor nt-form-control',
                    '[class.focus]': 'focused',
                    '[class.fill-screen]': 'fillScreen'
                }
            }),
            __param(2, core.Inject(core.PLATFORM_ID)),
            __param(3, core.Optional()), __param(3, core.Self()),
            __param(4, core.Optional()), __param(4, core.Inject(NT_MARKDOWN_EDITOR_ICONS)),
            __param(5, core.Optional()), __param(5, core.Inject(NT_MARKDOWN_EDITOR_CONFIG))
        ], NtMarkdownEditorComponent);
        return NtMarkdownEditorComponent;
    }(forms$1.NtFormFieldControl));

    var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var NtMarkdownEditorModule = (function () {
        function NtMarkdownEditorModule() {
        }
        NtMarkdownEditorModule = __decorate$1([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    markdown.NtMarkdownModule
                ],
                exports: [
                    markdown.NtMarkdownModule,
                    NtMarkdownEditorComponent
                ],
                declarations: [
                    NtMarkdownEditorComponent
                ],
            })
        ], NtMarkdownEditorModule);
        return NtMarkdownEditorModule;
    }());

    exports.DEFAULT_MARKDOWN_EDITOR_ICONS = DEFAULT_MARKDOWN_EDITOR_ICONS;
    exports.NT_MARKDOWN_EDITOR_ICONS = NT_MARKDOWN_EDITOR_ICONS;
    exports.NtMarkdownEditorComponent = NtMarkdownEditorComponent;
    exports.NtMarkdownEditorModule = NtMarkdownEditorModule;
    exports.ɵa = NtMarkdownEditorConfig;
    exports.ɵb = NT_MARKDOWN_EDITOR_CONFIG;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=markdown-editor.umd.js.map
